regina::NHandlebody Class Reference
Standard 3-Manifolds

Represents an arbitrary handlebody. More...

`#include <manifold/nhandlebody.h>`

Inheritance diagram for regina::NHandlebody:

## Public Member Functions

| NHandlebody (unsigned long newHandles, bool newOrientable)
| Creates a new handlebody with the given parameters. More...
| NHandlebody (const NHandlebody &cloneMe)
| Creates a clone of the given handlebody. More...
virtual | ~NHandlebody ()
| Destroys this handlebody. More...
unsigned long | getHandles () const
| Returns the number of handles of this handlebody. More...
bool | isOrientable () const
| Returns whether this handlebody is orientable. More...
bool | operator== (const NHandlebody &compare) const
| Determines whether this and the given handlebody represent the same 3-manifold. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
Public Member Functions inherited from regina::NManifold
virtual | ~NManifold ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents an arbitrary handlebody.

All optional NManifold routines except for NManifold::construct() are implemented for this class.

## Constructor & Destructor Documentation

regina::NHandlebody::NHandlebody | ( | unsigned long | newHandles,
|  | bool | newOrientable
| ) |  |

inline

Creates a new handlebody with the given parameters.

Parameters

  newHandles | the number of handles of the handlebody.
  newOrientable | `true` if the handlebody is to be orientable or `false` if the handlebody is to be non-orientable. This must be `true` if the handlebody has no handles.

regina::NHandlebody::NHandlebody | ( | const NHandlebody & | cloneMe | ) |

inline

Creates a clone of the given handlebody.

Parameters

  cloneMe | the handlebody to clone.

regina::NHandlebody::~NHandlebody | ( |  | ) |

inline virtual

Destroys this handlebody.

## Member Function Documentation

unsigned long regina::NHandlebody::getHandles | ( |  | ) | const

inline

Returns the number of handles of this handlebody.

Returns
  the number of handles.

NAbelianGroup* regina::NHandlebody::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

bool regina::NHandlebody::isOrientable | ( |  | ) | const

inline

Returns whether this handlebody is orientable.

Returns
  `true` if this handlebody is orientable, or `false` if this handlebody is non-orientable.

bool regina::NHandlebody::operator== | ( | const NHandlebody & | compare | ) | const

inline

Determines whether this and the given handlebody represent the same 3-manifold.

Parameters

  compare | the handlebody with which this will be compared.

Returns
  `true` if and only if this and the given handlebody are homeomorphic.

std::ostream& regina::NHandlebody::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream& regina::NHandlebody::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

The documentation for this class was generated from the following file:

- manifold/nhandlebody.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).